<?php
/**
 * Venustheme
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Venustheme EULA that is bundled with
 * this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.venustheme.com/LICENSE-1.0.html
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade the extension
 * to newer versions in the future. If you wish to customize the extension
 * for your needs please refer to http://www.venustheme.com/ for more information
 *
 * @category   Ves
 * @package    Ves_Blog
 * @copyright  Copyright (c) 2014 Venustheme (http://www.venustheme.com/)
 * @license    http://www.venustheme.com/LICENSE-1.0.html
 */

/**
 * Ves Blog Extension
 *
 * @category   Ves
 * @package    Ves_Blog
 * @author     Venustheme Dev Team <venustheme@gmail.com>
 */
class Ves_Blog_Block_Adminhtml_Comment_Edit_Tabs extends Mage_Adminhtml_Block_Widget_Tabs
{

  public function __construct()
  {
    parent::__construct();
    $this->setId('blog_form');
    $this->setDestElementId('edit_form');
    $this->setTitle(Mage::helper('ves_blog')->__('Comment Information'));
  }

  protected function _beforeToHtml()
  {
    $this->addTab('form_section', array(
      'label'     => Mage::helper('ves_blog')->__('General Information'),
      'title'     => Mage::helper('ves_blog')->__('General Information'),
      'content'   => $this->getLayout()->createBlock('ves_blog/adminhtml_comment_edit_tab_form')->toHtml(),
      ));

    return parent::_beforeToHtml();
  }
}