<?php
/**
 * Venustheme
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Venustheme EULA that is bundled with
 * this package in the file LICENSE.txt.
 * It is also available through the world-wide-web at this URL:
 * http://www.venustheme.com/LICENSE-1.0.html
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade the extension
 * to newer versions in the future. If you wish to customize the extension
 * for your needs please refer to http://www.venustheme.com/ for more information
 *
 * @category   Ves
 * @package    Ves_FAQ
 * @copyright  Copyright (c) 2014 Venustheme (http://www.venustheme.com/)
 * @license    http://www.venustheme.com/LICENSE-1.0.html
 */

/**
 * Ves FAQ Extension
 *
 * @category   Ves
 * @package    Ves_FAQ
 * @author     Venustheme Dev Team <venustheme@gmail.com>
 */
class Ves_FAQ_Block_Account_Dashboard extends Mage_Core_Block_Template
{
	/**
	 * Question collection
	 *
	 * @var Ves_FAQ_Model_Mysql4_Question_Collection
	 */
	protected $_collection = null;
	protected $_category = null;
	
	public function __construct(){
		if(!Mage::getStoreConfig('ves_faq/general_setting/enable'))
			return;
		parent::__construct();

		if(isset($attributes['template']) && $attributes['template']) {
			$my_template = $attributes['template'];
		} elseif ($this->hasData("template")) {
			$my_template = $this->getData("template");
		} else {
			$my_template = "ves/faq/account/question.phtml";
		}

		$this->setTemplate($my_template);
	}

	public function getCustomer()
	{
		return Mage::getSingleton('customer/session')->getCustomer();
	}

	public function getQuestionsApprove(){

		$customerId = $this->getCustomer()->getId();
		$collection = Mage::getModel('ves_faq/question')->getCollection();
		$collection->addFieldToFilter('status', array('eq'=>1))
		->addFieldToFilter('customer_id',array('eq' => $customerId))->setOrder('question_id','DESC');
		return $collection;
	}

	public function getQuestionsPendding(){
		$customerId = $this->getCustomer()->getId();
		$collection = Mage::getModel('ves_faq/question')->getCollection();
		$collection->addFieldToFilter('status', array('eq'=>2))
		->addFieldToFilter('customer_id',$customerId)->setOrder('question_id','DESC');
		return $collection;
	}

	/**
	 * Retrive list category
	 */
	public function getListCategory(){
		if(!$this->_category) {
			$store = Mage::app()->getStore();
			$collection = Mage::getModel('ves_faq/category')->getCollection()
						->addFieldToFilter('status', array('eq'=>1))
						->addStoreFilter($store)
						->setOrder('position','ASC');
			$this->_category = $collection;
		} 
		

		return $this->_category;
	}

	public function getCategoryTitle($categoryId = 0) {
		$category_title = "";

		if($categoryId) {
			$categories = $this->getListCategory();

			if($categories) {
				foreach($categories as $item) {

					if($categoryId == $item->getId()) {
						$category_title = $item->getName();
						break;
					}
				}
			}
		}
		return $category_title;
	}

	/**
	 * get value of the extension's configuration
	 *
	 * @return string
	 */
	public function getConfig( $key, $panel='module_setting', $default = ""){
		$return = "";
		$value = $this->getData($key);
		if($this->hasData($key) && $value !== null) {
			return $value;
		} else {

			$return = Mage::getStoreConfig("ves_faq/$panel/$key");

			if($return == "" && $default) {
				$return = $default;
			}
		}
		return $return;
	}
}